/* Printer Header */

#ifndef HEADER_PRINTER_H
#define HEADER_PRINTER_H

#include <inttypes.h>
#include "ubee512.h"
#include "z80.h"

#define PRINTER_STROBE_MS 1 * 3375

void printer_a_close (void);
void printer_b_close (void);
int printer_a_open (char *s, int action);
int printer_b_open (char *s, int action);

int printer_reset (void);
int printer_init (void);
int printer_deinit (void);
int printer_strobe_get (void);
void printer_strobe_set (void);
void printer_w (uint8_t data);

typedef struct printer_t
   {
    FILE *print_a_file;
    FILE *print_b_file;
    char printa[SSIZE1];
    char printb[SSIZE1];
    int count;
    int strobe;
    uint64_t delay;
   }printer_t; 

#endif     /* HEADER_PRINTER_H */
